﻿Imports System.IO
Imports Tea_Timer_Professional.DataSet1
Public Class frmHauptform
    Dim ZiehzeitMinuten As Integer = 0
    Dim ZiehzeitSekunden As Integer = 0
    Private Changeunterdrucken As Boolean = False
    Private _DataFile As New FileInfo("Tee.Xml")

#Region "Form Close und Load Event"
    Private Sub frmHauptform_Load(sender As Object, e As EventArgs) Handles MyBase.Load
        DataSet1.ReadXml(_DataFile.FullName)
    End Sub
    Private Sub frmHauptform_FormClosed(sender As Object, e As FormClosedEventArgs) Handles MyBase.FormClosed
        DataSet1.WriteXml(_DataFile.FullName)
    End Sub
#End Region

#Region "Klick Events - Buttons"
    Private Sub btnTemperaturMinus_Click(sender As Object, e As EventArgs) Handles btnTemperaturMinus.Click
        Changeunterdrucken = True
        AbkuehlzeitenBindingSource.MoveNext()
        Changeunterdrucken = False
    End Sub
    Private Sub btnTemperaturPlus_Click(sender As Object, e As EventArgs) Handles btnTemperaturPlus.Click
        Changeunterdrucken = True
        AbkuehlzeitenBindingSource.MovePrevious()
        Changeunterdrucken = False
    End Sub
    Private Sub btnZiehzeitPlus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitPlus.Click
        'Ziehzeit erhöhen
        Ziehzeitaendern("+")
    End Sub
    Private Sub btnZiehzeitMinus_Click(sender As Object, e As EventArgs) Handles btnZiehzeitMinus.Click
        'Ziehzeit verkürzen
        Ziehzeitaendern("-")
    End Sub
    Private Sub btnstart_Click(sender As Object, e As EventArgs) Handles btnstart.Click
        'Sub zum starten des Timers
        'prüfen ob Ton agespielt werden soll
        Dim Sound As Boolean = My.Settings.Sound
        'Ziehzeit in Sekunden umrechnen
        Dim Ziehzeit As Integer = ZiehzeitSekunden + ZiehzeitMinuten * 60
        'wenn keine Zeit vergeben wurde, abbruch der Sub
        If Ziehzeit = 0 Then
            MessageBox.Show("Bitte Ziehzeit eingeben.")
            Exit Sub
        End If
        'Temperaturzeit in Sekunden umrechnen
        Dim Abkuehlzeiten = DirectCast(DirectCast(AbkuehlzeitenBindingSource.Current, DataRowView).Row, AbkuehlzeitenRow)
        Dim abkuehlzeit As Integer = Abkuehlzeiten.ZeitSek + Abkuehlzeiten.ZeitMin * 60
        'aktuelle Form ausblenden
        Me.Hide()
        'Wenn Abkühlzeit größer als 0, dann zeigen der Form fTimer Abkühlen
        If Abkuehlzeit > 0 Then
            Dim frmAbkuehlzeit As New frmTimer
            With frmAbkuehlzeit
                .SetSound = Sound
                .SetZeit = Abkuehlzeit
                .SetZiehen = False
                .ShowDialog(Me)
            End With
        End If
        'zeigen der Form fTimer für die Ziehzeit
        Dim frmZiehzeit As New frmTimer
        With frmZiehzeit
            .SetSound = Sound
            .SetZeit = Ziehzeit
            .SetZiehen = True
            .ShowDialog(Me)
        End With
        Me.Show()
    End Sub
    Private Sub btnbeenden_Click(sender As Object, e As EventArgs) Handles btnbeenden.Click
        'Sub zum beenden des Programms
        Me.Close()
    End Sub
    Private Sub btnloeschen_Click(sender As Object, e As EventArgs) Handles btnloeschen.Click
        'Sub zum löschen aus dem Dataset
        DTTeesortenBindingSource.RemoveCurrent()
    End Sub
    Private Sub btnNeu_Click(sender As Object, e As EventArgs) Handles btnNeu.Click
        'Sub zum Eintragen eines neuen Tees
        DTTeesortenBindingSource.EditNew(Of frmNeu)
    End Sub
#End Region

#Region "Klick events Datagridviews"
    Private Sub DTTeesortenDataGridView_CellContentDoubleClick(sender As Object, e As DataGridViewCellEventArgs) Handles DTTeesortenDataGridView.CellContentDoubleClick
        'Sub zum bearbeiten eines Tees
        DTTeesortenBindingSource.EditCurrent(Of frmNeu)
    End Sub
#End Region

#Region "Klick Events - MenuStrip1"
    Private Sub BeendenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles BeendenToolStripMenuItem.Click
        Me.Close()
    End Sub
    Private Sub EinstellungenToolStripMenuItem_Click(sender As Object, e As EventArgs) Handles EinstellungenToolStripMenuItem.Click
        Dim frmEinstellungen As New frmEinstellungen
        frmEinstellungen.GefaessBindingSource.DataSource = Me.DataSet1
        frmEinstellungen.Show(Me)
    End Sub
#End Region

#Region "BindingSource Change Events"
    Private Sub DTTeesortenBindingSource_CurrentChanged(sender As Object, e As EventArgs) Handles DTTeesortenBindingSource.CurrentChanged
        Teeaendern()
    End Sub
    Private Sub AbkuehlzeitenBindingSource_CurrentChanged(sender As Object, e As EventArgs) Handles AbkuehlzeitenBindingSource.CurrentChanged
        Teeaendern()
    End Sub
#End Region

#Region "Subs und Funktionen"
    Private Sub Ziehzeitaendern(op As String)
        'Intervall aus den Einstellungen lesen
        Dim Intervall As Integer = My.Settings.Zeitintervall
        If op = "+" Then
            'Sekunden erhöhen
            ZiehzeitSekunden = ZiehzeitSekunden + Intervall
            'wenn Sekunden >= 60, dann Sekunden -60 und Minuten +1
            If ZiehzeitSekunden >= 60 Then
                ZiehzeitSekunden = ZiehzeitSekunden - 60
                ZiehzeitMinuten = ZiehzeitMinuten + 1
            End If
        Else
            'Sekunden verringern
            'Abbruch, wenn Minuten und Sekunden auf 0 stehen
            If ZiehzeitMinuten = 0 AndAlso ZiehzeitSekunden = 0 Then Exit Sub
            ZiehzeitSekunden = ZiehzeitSekunden - Intervall
            'wenn Sekunden < 0, dann Sekunden +60 und Minuten -1
            If ZiehzeitSekunden < 0 Then
                ZiehzeitSekunden = ZiehzeitSekunden + 60
                ZiehzeitMinuten = ZiehzeitMinuten - 1
            End If
        End If
        lblZiehzeitMinuten.Text = ZiehzeitMinuten.ToString("00")
        lblZiehzeitSekunden.Text = ZiehzeitSekunden.ToString("00")
    End Sub
    Private Sub Teeaendern()
        If Not Changeunterdrucken Then
            If GefaessBindingSource.Current Is Nothing Then Exit Sub
            Dim aktuelleTeesorte = DirectCast(DirectCast(DTTeesortenBindingSource.Current, DataRowView).Row, DTTeesortenRow)
            Dim aktuellesGefaess = DirectCast(DirectCast(GefaessBindingSource.Current, DataRowView).Row, GefaessRow)
            Dim AktuelleAbkuehlzeit = aktuellesGefaess.GetAbkuehlzeitenRows().FirstOrDefault(Function(x) x.Temperatur = aktuelleTeesorte.Temperatur)
            If AktuelleAbkuehlzeit Is Nothing Then
                MessageBox.Show($"Uh oh, die Abk�hlzeit f�r die Temperatur {aktuelleTeesorte.Temperatur} gibt's f�r das Gef�� {aktuellesGefaess.Name} gar nicht :-(")
                Exit Sub
            End If
            For i = 0 To Me.AbkuehlzeitenBindingSource.Count - 1
                Dim Abkuehlzeiten = DirectCast(DirectCast(AbkuehlzeitenBindingSource(i), DataRowView).Row, AbkuehlzeitenRow)
                If AktuelleAbkuehlzeit.Temperatur = Abkuehlzeiten.Temperatur Then
                    AbkuehlzeitenBindingSource.Position = i
                    Exit For
                End If
            Next
            ZiehzeitSekunden = aktuelleTeesorte.Sekunden
            ZiehzeitMinuten = aktuelleTeesorte.Minuten
            lblZiehzeitMinuten.Text = ZiehzeitMinuten.ToString
            lblZiehzeitSekunden.Text = ZiehzeitSekunden.ToString
        End If
    End Sub


#End Region




End Class
